/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Alamat;
import com.portofolio.entity.vo.AlamatId;

@Lazy
@Repository("alamatDao")
public interface AlamatDao extends CrudRepository<Alamat, AlamatId> {


	@Query(QListAll + " and id.kdProfile=:kdProfile and model.enumAlamat=:enumAlamat")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled,@Param("enumAlamat") String enumAlamat, Pageable page);

	@Query(QListAll + " and model.enumAlamat=:enumAlamat and id.kdProfile=:kdProfile and  lower(CONCAT(model.alamatLengkap,' RT ',model.rTRW,',Desa/Kel ',desaKelurahan.namaDesaKelurahan,',Kecamatan ',kecamatan.namaKecamatan,',',kotaKabupaten.namaKotaKabupaten,',',propinsi.namaPropinsi,',',model.kodePos )) like %:alamatLengkap% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("alamatLengkap") String alamatLengkap, @Param("statusEnabled") boolean statusEnabled,@Param("enumAlamat") String enumAlamat,Pageable page);

	@Query(QListAll + " and  model.enumAlamat=:enumAlamatProfile ")
	Page<Map<String, Object>> gridAlamatProfile(@Param("enumAlamatProfile") String enumAlamatProfile,@Param("statusEnabled") boolean statusEnabled, Pageable pageReq);

	@Query(QListAll + " and model.enumAlamat=:enumAlamatProfile and  lower(CONCAT(model.alamatLengkap,' RT ',model.rTRW,',Desa/Kel ',desaKelurahan.namaDesaKelurahan,',Kecamatan ',kecamatan.namaKecamatan,',',kotaKabupaten.namaKotaKabupaten,',',propinsi.namaPropinsi,',',model.kodePos )) like %:alamatLengkap% ")
	Page<Map<String, Object>> gridAlamatProfile(@Param("enumAlamatProfile") String enumAlamatProfile,@Param("alamatLengkap") String alamatLengkap, @Param("statusEnabled") boolean statusEnabled, Pageable pageReq);

	@Query(QListAll + " and id.kdProfile=:kdProfile and  model.id.kdAlamat=:kdAlamat")
	Map<String, Object> findByKdAlamat(@Param("kdProfile") Integer kdProfile, @Param("kdAlamat") Integer kdAlamat,@Param("statusEnabled") boolean statusEnabled);

	@Query("select model from Alamat model left join model.id id where id.kdProfile=:kdProfile and model.statusEnabled=true and model.kdRekanan is null and model.kdPegawai is null ")
	List<Alamat> findAlamatProfile(@Param("kdProfile") Integer kdProfile);
	
	@Query(QListAll+ " and  id.kdProfile=:kdProfile and model.kdRekanan is null and model.kdPegawai is null ")
	List<Map<String,Object>> findAlamatProfile(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled);
	
	@Query(QListAll+ " and id.kdProfile=:kdProfile and model.kdPegawai=:kdPegawai and model.statusEnabled=:statusEnabled ")
	List<Map<String,Object>> findByKdPegawai(@Param("kdProfile") Integer kdProfile, @Param("kdPegawai") String kdPegawai,@Param("statusEnabled") boolean statusEnabled);
	
	@Query("select model from Alamat model left join model.id id where id.kdProfile=:kdProfile and  model.kdPegawai=:kdPegawai and model.statusEnabled=true ")
	List<Alamat> findByKdPegawai(@Param("kdProfile") Integer kdProfile, @Param("kdPegawai") String kdPegawai);
	
	@Query(QListAll+ " and id.kdProfile=:kdProfile and model.kdPerson=:kdPerson and model.statusEnabled=:statusEnabled ")
	List<Map<String,Object>> findByKdPerson(@Param("kdProfile") Integer kdProfile, @Param("kdPerson") String kdPerson,@Param("statusEnabled") boolean statusEnabled);
	
	@Query("select model from Alamat model left join model.id id where id.kdProfile=:kdProfile and  model.kdPerson=:kdPerson and model.statusEnabled=true ")
	List<Alamat> findByKdPerson(@Param("kdProfile") Integer kdProfile, @Param("kdPerson") String kdPerson);
	
	
	String QListAll = "select new map("
			+ "  CONCAT(model.alamatLengkap,' RT ',model.rTRW,',Desa/Kel ',desaKelurahan.namaDesaKelurahan,',Kecamatan ',kecamatan.namaKecamatan,',',kotaKabupaten.namaKotaKabupaten,',',propinsi.namaPropinsi,',',model.kodePos ) as concatAlamatLengkap"
			+ ", model.id.kdAlamat as kdAlamat"
			+ ", model.id.kdProfile as kdProfile " 
			+ ", model.kdJenisAlamat as kdJenisAlamat "
			+ ", model.alamatLengkap as alamatLengkap "
			+ ", model.kdDesaKelurahan as kdDesaKelurahan " 
			+ ", model.rTRW as rTRW " 
			+ ", model.kdKecamatan as kdKecamatan " 
			+ ", model.kdKotaKabupaten as kdKotaKabupaten " 
			+ ", model.kdPropinsi as kdPropinsi " 
			+ ", model.kodePos as kodePos " 
			+ ", model.kdNegara as kdNegara "
			+ ", model.fixedPhone1 as fixedPhone1 " 
			//+ ", model.fixedPhone2 as fixedPhone2 "
			+ ", model.mobilePhone1 as mobilePhone1 " 
			//+ ", model.mobilePhone2 as mobilePhone2 "
			+ ", model.faksimile1 as faksimile1 " 
			//+ ", model.faksimile2 as faksimile2 "
			+ ", model.alamatEmail as alamatEmail " 
			+ ", model.website as website "
			+ ", model.blackBerry as blackBerry " 
			+ ", model.enumAlamat as enumAlamat " 
			+ ", model.whatsApp as whatsApp "
			+ ", model.yahooMessenger as yahooMessenger "
			//+ ", model.twitter as twitter "
			//+ ", model.facebook as facebook " 
			//+ ", model.line as line "
			//+ ", model.isPrimaryAddress as isPrimaryAddress "
			//+ ", model.isShippingAddress as isShippingAddress "
			//+ ", model.isBillingAddress as isBillingAddress " 
			//+ ", model.noCM as noCM "
			//+ ", model.kdPegawai as kdPegawai " 
			//+ ", model.kdHubunganKeluarga as kdHubunganKeluarga "
			//+ ", model.kdRekanan as kdRekanan " 
			//+ ", model.kdBankAccount as kdBankAccount "
			+ ", model.keteranganLainnya as keteranganLainnya " 
			+ ", model.tglDaftar as tglDaftar "
			+ ", model.statusEnabled as statusEnabled " 
			+ ", model.noRec as noRec "
			+ ", model.garisLintangLatitude as garisLintangLatitude "
			+ ", model.garisBujurLongitude as garisBujurLongitude " 
			//+ ", model.radiusAlamat as radiusAlamat "
			+ ", model.version as version"
			+ ", negara.namaNegara as namaNegara" 
			+ ", propinsi.namaPropinsi as namaPropinsi "
			+ ", kotaKabupaten.namaKotaKabupaten as namaKotaKabupaten" 
			+ ", kecamatan.namaKecamatan as namaKecamatan"
			+ ", desaKelurahan.namaDesaKelurahan as namaDesaKelurahan"
			+ ", jenisAlamat.namaJenisAlamat as namaJenisAlamat ) " 
			+ " from Alamat model "
			+ " left join model.negara negara " 
			+ " left join model.propinsi propinsi "
			+ " left join model.kotaKabupaten kotaKabupaten " 
			+ " left join model.kecamatan kecamatan "
			+ " left join model.desaKelurahan desaKelurahan " 
			+ " left join model.jenisAlamat jenisAlamat "
			+ " left join model.id id  where model.statusEnabled=:statusEnabled ";


}
